BEGIN;
CREATE TABLE IF NOT EXISTS awsaccount () INHERITS (aws);
CREATE TABLE IF NOT EXISTS awsathenadatacatalog () INHERITS (aws);
CREATE TABLE IF NOT EXISTS awsbackupbackupvault () INHERITS (aws);
CREATE TABLE IF NOT EXISTS awsbatchcomputeenvironment () INHERITS (aws);
CREATE TABLE IF NOT EXISTS awsbatchjobdefinition () INHERITS (aws);
CREATE TABLE IF NOT EXISTS awsbatchjobqueue () INHERITS (aws);
CREATE TABLE IF NOT EXISTS awscassandrakeyspace () INHERITS (aws);
CREATE TABLE IF NOT EXISTS awscloudfrontdistribution () INHERITS (aws);
CREATE TABLE IF NOT EXISTS awscloudsearchdomain () INHERITS (aws);
CREATE TABLE IF NOT EXISTS awscredentialreport () INHERITS (aws);
CREATE TABLE IF NOT EXISTS awsdynamodbglobaltable () INHERITS (aws);
CREATE TABLE IF NOT EXISTS awsdynamodbtable () INHERITS (aws);
CREATE TABLE IF NOT EXISTS awsec2eip () INHERITS (aws);
CREATE TABLE IF NOT EXISTS awsec2instance () INHERITS (aws);
CREATE TABLE IF NOT EXISTS awsec2networkacl () INHERITS (aws);
CREATE TABLE IF NOT EXISTS awsec2networkinterface () INHERITS (aws);
CREATE TABLE IF NOT EXISTS awsec2securitygroup () INHERITS (aws);
CREATE TABLE IF NOT EXISTS awsec2volume () INHERITS (aws);
CREATE TABLE IF NOT EXISTS awsec2vpc () INHERITS (aws);
CREATE TABLE IF NOT EXISTS awsec2vpcpeeringconnection () INHERITS (aws);
CREATE TABLE IF NOT EXISTS awsecscluster () INHERITS (aws);
CREATE TABLE IF NOT EXISTS awsefsfilesystem () INHERITS (aws);
CREATE TABLE IF NOT EXISTS awsekscluster () INHERITS (aws);
CREATE TABLE IF NOT EXISTS awselasticachecluster () INHERITS (aws);
CREATE TABLE IF NOT EXISTS awselasticbeanstalk () INHERITS (aws);
CREATE TABLE IF NOT EXISTS awselasticloadbalancingloadbalancer () INHERITS (aws);
CREATE TABLE IF NOT EXISTS awselasticloadbalancingv2loadbalancer () INHERITS (aws);
CREATE TABLE IF NOT EXISTS awselasticsearchdomain () INHERITS (aws);
CREATE TABLE IF NOT EXISTS awsemrcluster () INHERITS (aws);
CREATE TABLE IF NOT EXISTS awsfsxfilesystem () INHERITS (aws);
CREATE TABLE IF NOT EXISTS awsglaciervault () INHERITS (aws);
CREATE TABLE IF NOT EXISTS awsiamgroup () INHERITS (aws);
CREATE TABLE IF NOT EXISTS awsiampolicy () INHERITS (aws);
CREATE TABLE IF NOT EXISTS awsiamrole () INHERITS (aws);
CREATE TABLE IF NOT EXISTS awsiamuser () INHERITS (aws);
CREATE TABLE IF NOT EXISTS awskmskey () INHERITS (aws);
CREATE TABLE IF NOT EXISTS awslakeformationresource () INHERITS (aws);
CREATE TABLE IF NOT EXISTS awslambdafunction () INHERITS (aws);
CREATE TABLE IF NOT EXISTS awslightsaildatabase () INHERITS (aws);
CREATE TABLE IF NOT EXISTS awslightsailinstance () INHERITS (aws);
CREATE TABLE IF NOT EXISTS awslightsailloadbalancer () INHERITS (aws);
CREATE TABLE IF NOT EXISTS awsneptunecluster () INHERITS (aws);
CREATE TABLE IF NOT EXISTS awsneptuneinstance () INHERITS (aws);
CREATE TABLE IF NOT EXISTS awsqldbledger () INHERITS (aws);
CREATE TABLE IF NOT EXISTS awsrdsdbinstance () INHERITS (aws);
CREATE TABLE IF NOT EXISTS awsredshiftcluster () INHERITS (aws);
CREATE TABLE IF NOT EXISTS awsregion () INHERITS (aws);
CREATE TABLE IF NOT EXISTS awsroute53hostedzone () INHERITS (aws);
CREATE TABLE IF NOT EXISTS awss3bucket () INHERITS (aws);
CREATE TABLE IF NOT EXISTS awss3bucketobject () INHERITS (aws);
CREATE TABLE IF NOT EXISTS awssecretsmanager () INHERITS (aws);
CREATE TABLE IF NOT EXISTS awsstoragegatewaygateway () INHERITS (aws);
CREATE TABLE IF NOT EXISTS orvnshadowaccount () INHERITS (aws);

INSERT INTO awsaccount SELECT * FROM aws WHERE resourcetype = 'AWS::Account' AND NOT EXISTS (SELECT * FROM awsaccount);
INSERT INTO awsathenadatacatalog SELECT * FROM aws WHERE resourcetype = 'AWS::Athena::DataCatalog' AND NOT EXISTS (SELECT * FROM awsathenadatacatalog);
INSERT INTO awsbackupbackupvault SELECT * FROM aws WHERE resourcetype = 'AWS::Backup::BackupVault' AND NOT EXISTS (SELECT * FROM awsbackupbackupvault);
INSERT INTO awsbatchcomputeenvironment SELECT * FROM aws WHERE resourcetype = 'AWS::Batch::ComputeEnvironment' AND NOT EXISTS (SELECT * FROM awsbatchcomputeenvironment);
INSERT INTO awsbatchjobdefinition SELECT * FROM aws WHERE resourcetype = 'AWS::Batch::JobDefinition' AND NOT EXISTS (SELECT * FROM awsbatchjobdefinition);
INSERT INTO awsbatchjobqueue SELECT * FROM aws WHERE resourcetype = 'AWS::Batch::JobQueue' AND NOT EXISTS (SELECT * FROM awsbatchjobqueue);
INSERT INTO awscassandrakeyspace SELECT * FROM aws WHERE resourcetype = 'AWS::Cassandra::Keyspace' AND NOT EXISTS (SELECT * FROM awscassandrakeyspace);
INSERT INTO awscloudfrontdistribution SELECT * FROM aws WHERE resourcetype = 'AWS::CloudFront::Distribution' AND NOT EXISTS (SELECT * FROM awscloudfrontdistribution);
INSERT INTO awscloudsearchdomain SELECT * FROM aws WHERE resourcetype = 'AWS::CloudSearch::Domain' AND NOT EXISTS (SELECT * FROM awscloudsearchdomain);
INSERT INTO awscredentialreport SELECT * FROM aws WHERE resourcetype = 'AWS::CredentialReport' AND NOT EXISTS (SELECT * FROM awscredentialreport);
INSERT INTO awsdynamodbglobaltable SELECT * FROM aws WHERE resourcetype = 'AWS::DynamoDB::GlobalTable' AND NOT EXISTS (SELECT * FROM awsdynamodbglobaltable);
INSERT INTO awsdynamodbtable SELECT * FROM aws WHERE resourcetype = 'AWS::DynamoDB::Table' AND NOT EXISTS (SELECT * FROM awsdynamodbtable);
INSERT INTO awsec2eip SELECT * FROM aws WHERE resourcetype = 'AWS::EC2::EIP' AND NOT EXISTS (SELECT * FROM awsec2eip);
INSERT INTO awsec2instance SELECT * FROM aws WHERE resourcetype = 'AWS::EC2::Instance' AND NOT EXISTS (SELECT * FROM awsec2instance);
INSERT INTO awsec2networkacl SELECT * FROM aws WHERE resourcetype = 'AWS::EC2:NetworkAcl' AND NOT EXISTS (SELECT * FROM awsec2networkacl);
INSERT INTO awsec2networkinterface SELECT * FROM aws WHERE resourcetype = 'AWS::EC2::NetworkInterface' AND NOT EXISTS (SELECT * FROM awsec2networkinterface);
INSERT INTO awsec2securitygroup SELECT * FROM aws WHERE resourcetype = 'AWS::EC2::SecurityGroup' AND NOT EXISTS (SELECT * FROM awsec2securitygroup);
INSERT INTO awsec2volume SELECT * FROM aws WHERE resourcetype = 'AWS::EC2:Volume' AND NOT EXISTS (SELECT * FROM awsec2volume);
INSERT INTO awsec2vpcpeeringconnection SELECT * FROM aws WHERE resourcetype = 'AWS::EC2::VPCPeeringConnection' AND NOT EXISTS (SELECT * FROM awsec2vpcpeeringconnection);
INSERT INTO awsec2vpc SELECT * FROM aws WHERE resourcetype = 'AWS::EC2::VPC' AND NOT EXISTS (SELECT * FROM awsec2vpc);
INSERT INTO awsecscluster SELECT * FROM aws WHERE resourcetype = 'AWS::ECS::Cluster' AND NOT EXISTS (SELECT * FROM awsecscluster);
INSERT INTO awsefsfilesystem SELECT * FROM aws WHERE resourcetype = 'AWS::EFS::FileSystem' AND NOT EXISTS (SELECT * FROM awsefsfilesystem);
INSERT INTO awsekscluster SELECT * FROM aws WHERE resourcetype = 'AWS::EKS::Cluster' AND NOT EXISTS (SELECT * FROM awsekscluster);
INSERT INTO awselasticachecluster SELECT * FROM aws WHERE resourcetype = 'AWS::ElastiCache::Cluster' AND NOT EXISTS (SELECT * FROM awselasticachecluster);
INSERT INTO awselasticbeanstalk SELECT * FROM aws WHERE resourcetype = 'AWS::ElasticBeanstalk' AND NOT EXISTS (SELECT * FROM awselasticbeanstalk);
INSERT INTO awselasticloadbalancingloadbalancer SELECT * FROM aws WHERE resourcetype = 'AWS::ElasticLoadBalancing::LoadBalancer' AND NOT EXISTS (SELECT * FROM awselasticloadbalancingloadbalancer);
INSERT INTO awselasticloadbalancingv2loadbalancer SELECT * FROM aws WHERE resourcetype = 'AWS::ElasticLoadBalancingV2::LoadBalancer' AND NOT EXISTS (SELECT * FROM awselasticloadbalancingv2loadbalancer);
INSERT INTO awselasticsearchdomain SELECT * FROM aws WHERE resourcetype = 'AWS::Elasticsearch::Domain' AND NOT EXISTS (SELECT * FROM awselasticsearchdomain);
INSERT INTO awsemrcluster SELECT * FROM aws WHERE resourcetype = 'AWS::EMR::Cluster' AND NOT EXISTS (SELECT * FROM awsemrcluster);
INSERT INTO awsfsxfilesystem SELECT * FROM aws WHERE resourcetype = 'AWS::FSx::FileSystem' AND NOT EXISTS (SELECT * FROM awsfsxfilesystem);
INSERT INTO awsglaciervault SELECT * FROM aws WHERE resourcetype = 'AWS::Glacier::Vault' AND NOT EXISTS (SELECT * FROM awsglaciervault);
INSERT INTO awsiamgroup SELECT * FROM aws WHERE resourcetype = 'AWS::IAM::Group' AND NOT EXISTS (SELECT * FROM awsiamgroup);
INSERT INTO awsiampolicy SELECT * FROM aws WHERE resourcetype = 'AWS::IAM::Policy' AND NOT EXISTS (SELECT * FROM awsiampolicy);
INSERT INTO awsiamrole SELECT * FROM aws WHERE resourcetype = 'AWS::IAM::Role' AND NOT EXISTS (SELECT * FROM awsiamrole);
INSERT INTO awsiamuser SELECT * FROM aws WHERE resourcetype = 'AWS::IAM::User' AND NOT EXISTS (SELECT * FROM awsiamuser);
INSERT INTO awskmskey SELECT * FROM aws WHERE resourcetype = 'AWS::Kms::Key' AND NOT EXISTS (SELECT * FROM awskmskey);
INSERT INTO awslakeformationresource SELECT * FROM aws WHERE resourcetype = 'AWS::LakeFormation::Resource' AND NOT EXISTS (SELECT * FROM awslakeformationresource);
INSERT INTO awslambdafunction SELECT * FROM aws WHERE resourcetype = 'AWS::Lambda::Function' AND NOT EXISTS (SELECT * FROM awslambdafunction);
INSERT INTO awslightsaildatabase SELECT * FROM aws WHERE resourcetype = 'AWS::Lightsail::Database' AND NOT EXISTS (SELECT * FROM awslightsaildatabase);
INSERT INTO awslightsailinstance SELECT * FROM aws WHERE resourcetype = 'AWS::Lightsail::Instance' AND NOT EXISTS (SELECT * FROM awslightsailinstance);
INSERT INTO awslightsailloadbalancer SELECT * FROM aws WHERE resourcetype = 'AWS::Lightsail::LoadBalancer' AND NOT EXISTS (SELECT * FROM awslightsailloadbalancer);
INSERT INTO awsneptunecluster SELECT * FROM aws WHERE resourcetype = 'AWS::Neptune::Cluster' AND NOT EXISTS (SELECT * FROM awsneptunecluster);
INSERT INTO awsneptuneinstance SELECT * FROM aws WHERE resourcetype = 'AWS::Neptune::Instance' AND NOT EXISTS (SELECT * FROM awsneptuneinstance);
INSERT INTO awsqldbledger SELECT * FROM aws WHERE resourcetype = 'AWS::Qldb::Ledger' AND NOT EXISTS (SELECT * FROM awsqldbledger);
INSERT INTO awsrdsdbinstance SELECT * FROM aws WHERE resourcetype = 'AWS::RDS::DBInstance' AND NOT EXISTS (SELECT * FROM awsrdsdbinstance);
INSERT INTO awsredshiftcluster SELECT * FROM aws WHERE resourcetype = 'AWS::Redshift::Cluster' AND NOT EXISTS (SELECT * FROM awsredshiftcluster);
INSERT INTO awsregion SELECT * FROM aws WHERE resourcetype = 'AWS::Region' AND NOT EXISTS (SELECT * FROM awsregion);
INSERT INTO awsroute53hostedzone SELECT * FROM aws WHERE resourcetype = 'AWS::Route53::HostedZone' AND NOT EXISTS (SELECT * FROM awsroute53hostedzone);
INSERT INTO awss3bucketobject SELECT * FROM aws WHERE resourcetype = 'AWS::S3::BucketObject' AND NOT EXISTS (SELECT * FROM awss3bucketobject);
INSERT INTO awss3bucket SELECT * FROM aws WHERE resourcetype = 'AWS::S3::Bucket' AND NOT EXISTS (SELECT * FROM awss3bucket);
INSERT INTO awssecretsmanager SELECT * FROM aws WHERE resourcetype = 'AWS::SecretsManager' AND NOT EXISTS (SELECT * FROM awssecretsmanager);
INSERT INTO awsstoragegatewaygateway SELECT * FROM aws WHERE resourcetype = 'AWS::StorageGateway::Gateway' AND NOT EXISTS (SELECT * FROM awsstoragegatewaygateway);
INSERT INTO orvnshadowaccount SELECT * FROM aws WHERE resourcetype = 'ORVN::ShadowAccount' AND NOT EXISTS (SELECT * FROM orvnshadowaccount);

DO $$
    BEGIN
        PERFORM TRUE
        FROM   information_schema.columns
        WHERE  table_name  = 'dmap'
          AND column_name = 'dmapnode';
        IF NOT FOUND THEN
            TRUNCATE aws;
        END IF;
    END;
$$;
COMMIT;
